
#ifndef __MK5B_MDL_HPP__
#define __MK5B_MDL_HPP__
/** 
 * Mk5B_mdl: Mark5b Data server model
 *  corresponding to the K5VSI_mdl.
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (水, 03  7月 2013) $
 * $Id: Mk5B_mdl.hpp 56 2013-07-03 11:40:14Z vlbi $ 
 */
 

#include "Mk5B_header.hpp"

class Mk5B_Model{
  vector <uint8_t> dat_buf;
  uint8_t enc_table[256]; ///< Encoding Table 
  VLBI_Frame *vlbi_frame;
  string m5fname; // mark5 fname
  DAS_Info das_inf;
  File *rfp;
  Mk5B_Hdr m5bhdr;
  int32_t remain;
  uint8_t *pb;
public:
  Mk5B_Model():vlbi_frame(0),rfp(0),remain(0),pb(0){make_enctab();}
  ~Mk5B_Model(){if(rfp!=0) fclose(rfp);}
  void  Set_outframe(VLBI_Frame* f){vlbi_frame=f;}
  void Set_mk5file(const char* name){m5fname = name;}
  void make_enctab();
  int Set_Sparam(const int n, const int q, const uint32_t s){
    das_inf.Set_Param(n,q,s); return 0; }
  /// Reading data/finding the first 1pps top/Read 1sec of data to buf.
  int int Get_FirstData(const int32_t size);
  int Eof()const {return feof(rfp);}
  /// Extracting data of the channel ich to the buffer.
  int Convert(const int ich, uint8_t *buf);
};

#endif
