#include "InMem_mdl.hpp"

/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (水, 03  7月 2013) $
 * $Id: InMem-test.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

char* me;

void usage(){
  cerr <<  "Usage: " << me 
       << " Testing InMem-model\n";
  exit(1); 

}

int main(int argc, char* argv[]){
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  int k=0;
    while (k >= 0) { 
    switch (k = getopt(argc, argv, "h")) { 
    case 'h':   
    case '?':    usage(); break;
    }
  }

  const int length=86400;
  string Stname("Kashima34");
  string Stid("kb");

  DAS_Info indas( 32000000, 4, 2 );
  InDev_Model *input_mdl(0);
  
  VLBI_Frame* in_vlbi_frame(0);
  in_vlbi_frame = new K5VSSP32_Frame;
  in_vlbi_frame->Set_DasInfo( indas );

  input_mdl = new InMem_Model(length);

  input_mdl->Set_VlbiFrame(in_vlbi_frame);
  input_mdl->Set_StnameID(Stname.c_str(),Stid.c_str());

  input_mdl->Ready();
  input_mdl->start(); // reading data Started 
  
  uint32_t pagesize = input_mdl->PageLength();
  printf("Pagesize = %u Byte\n", pagesize*4 );
  printf("FirstPage = %d \n", input_mdl->FirstPage());
  while(1){
    printf("FirstPage = %d: ", input_mdl->FirstPage());
    printf("PageState= %s\n", input_mdl->StrPageState(1).c_str());
    usleep(1000000);
  }


}
